package org.netkernel.lang.trl.endpoint;

import java.io.ByteArrayOutputStream;

import org.netkernel.lang.trl.rep.IStreamEditorRep;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.nkf.INKFResponse;
import org.netkernel.layer0.nkf.INKFResponseReadOnly;
import org.netkernel.layer0.representation.ByteArrayRepresentation;
import org.netkernel.layer0.representation.IReadableBinaryStreamRepresentation;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;

public class SEDRuntime extends StandardAccessorImpl
{
	public SEDRuntime()
	{	this.declareThreadSafe();		
	}

	@Override
	public void onSource(INKFRequestContext aContext) throws Exception
	{	IStreamEditorRep editor=aContext.source("arg:operator", IStreamEditorRep.class);
		INKFResponseReadOnly opd=aContext.sourceForResponse("arg:operand", IReadableBinaryStreamRepresentation.class);
		IReadableBinaryStreamRepresentation rbs=(IReadableBinaryStreamRepresentation)opd.getRepresentation();
		ByteArrayOutputStream baos=new ByteArrayOutputStream(2048);
		editor.process(rbs.getInputStream(),baos);
		ByteArrayRepresentation ba=new ByteArrayRepresentation(baos.toByteArray());
		INKFResponse resp=aContext.createResponseFrom(ba);
		resp.setMimeType(opd.getMimeType());
	}

}
