package org.netkernel.lang.trl.endpoint;

import org.netkernel.lang.trl.rep.IStreamEditorRep;
import org.netkernel.lang.trl.rep.StreamEditorRep;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.module.standard.endpoint.StandardTransreptorImpl;
import org.netkernel.xml.xda.IXDAReadOnly;
import org.netkernel.xml.xda.IXDAReadOnlyIterator;

public class StreamEditorTransreptor extends StandardTransreptorImpl
{
	public StreamEditorTransreptor()
	{
		this.declareThreadSafe();
		this.declareToRepresentation(IStreamEditorRep.class);
	}

	@Override
	public void onTransrept(INKFRequestContext context) throws Exception
	{
		IXDAReadOnly xda = context.sourcePrimary(IXDAReadOnly.class);
		IXDAReadOnlyIterator roi = xda.readOnlyIterator("/sed/pattern");
		StreamEditorRep se = new StreamEditorRep();
		while (roi.hasNext())
		{
			roi.next();
			String regex = roi.getText("regex", true);
			String replace = roi.getText("replace", false);
			se.addPattern(regex, replace);
		}
		context.createResponseFrom(se);
	}

}
