package org.netkernel.lang.trl.rep;

import java.io.*;
import java.util.*;
import java.util.regex.*;

public class StreamEditorRep implements IStreamEditorRep
{
	private HashMap<Pattern,String> mMap;
	
	/** Creates a new instance of StreamEditor */
	public StreamEditorRep()
	{	mMap=new HashMap<Pattern, String>(16);
	}
	
	public void addPattern(String aPattern, String aReplacement)
	{	mMap.put(Pattern.compile(aPattern),aReplacement);
	}
	
	public void process(InputStream in, OutputStream out) throws Exception
	{	LineNumberReader lnr=new LineNumberReader(new InputStreamReader(in),1024);
		String line;
		while((line=lnr.readLine())!=null)
		{	Iterator it=mMap.keySet().iterator();
			while(it.hasNext())
			{	Pattern p=(Pattern)it.next();
				Matcher m=p.matcher(line);
				line=m.replaceAll(mMap.get(p));
			}
			out.write(line.getBytes());
			out.write('\n');
		}
		out.close();
	}

}
